/**
* Filename: options.js
* Created:  10.04.2006
* Creator:  Jan Pavek <jan@pavek.de>
*
* Revisions:
*   29.06.2006 - jp
*       chg: big big ones
*   02.03.2007 - jp
*
*/

var nsIFilePicker = Components.interfaces.nsIFilePicker;
var strings;


function MabData( description, fileName )
{
    this.description = description;
    this.fileName = fileName;
} // MabData

function compareMabData( a, b )
{
    if( a.description < b.description )
        return -1;
    if( a.description > b.description )
        return 1;
    return 0;
} // compareMabData



function init() 
{
    strings = document.getElementById("strings");

    var filePath;
    var syncType;
    var mabCount;
    var useAutoSync = false;
    var useSyncTime = false;
    var syncTime = 0;
    var mabSync = new Array( maxMabCount );
    
    for( mabCount = 0; mabCount < maxMabCount; mabCount++ )
    {
      mabSync[mabCount] = new MabSyncData();
      mabSync[mabCount].load( mabCount );
    } // for


    // list address books
    var mabListExport = document.getElementById("MabListExport");
    var mabListImport = document.getElementById("MabListImport");

    mabListExport.appendItem( strings.getString("all"), "", "" );
    mabListImport.appendItem( strings.getString("automatic"), "", "" );

    var cn = directory.childNodes;
    var aBook = cn.getNext();
    var mabNames = new Array();

    while( aBook != null )
    {
        var cur = aBook.QueryInterface(Components.interfaces.nsIAbDirectory);
        mabNames.push( new MabData(cur.directoryProperties.description,cur.directoryProperties.fileName) );
        try
        {
            aBook = cn.getNext();
        }
        catch(e)
        {
            break;
        } // catch
    } // while

    mabNames.sort( compareMabData );

    for( i = 0; i < mabNames.length; i++ )
    {
        mabData = mabNames[i];
        mabListExport.appendItem( mabData.description, mabData.fileName, "" );
        mabListImport.appendItem( mabData.description, mabData.fileName, "" );

        for( mabCount = 0; mabCount < maxMabCount; mabCount++ )
        {
          document.getElementById("MabList"+mabCount+"_import").
            appendItem( mabData.description, mabData.fileName, "" );
          document.getElementById("MabList"+mabCount+"_export").
            appendItem( mabData.description, mabData.fileName, "" );

          if( mabSync[mabCount].mabToImport == mabData.fileName )
            document.getElementById("MabList"+mabCount+"_import").selectedIndex = i;
          if( mabSync[mabCount].mabToExport == mabData.fileName )
            document.getElementById("MabList"+mabCount+"_export").selectedIndex = i;
        } // for
    } // for

    mabListExport.selectedIndex = 0;
    mabListImport.selectedIndex = 0;

    for( mabCount = 0; mabCount < maxMabCount; mabCount++ )
    {
        document.getElementById("MabList"+mabCount+"_import").
          insertItemAt(0,strings.getString("automatic"),"","");
        document.getElementById("MabList"+mabCount+"_export").
          insertItemAt(0,strings.getString("all"),"","");

        if( document.getElementById("MabList"+mabCount+"_import").selectedIndex < 0 )
            document.getElementById("MabList"+mabCount+"_import").selectedIndex = 0;
        if( document.getElementById("MabList"+mabCount+"_export").selectedIndex < 0 )
            document.getElementById("MabList"+mabCount+"_export").selectedIndex = 0;

        document.getElementById("MabSyncActive"+mabCount).checked =
          mabSync[mabCount].syncActive;
        document.getElementById("MabNew"+mabCount+"_import").checked =
          mabSync[mabCount].importNew;
        document.getElementById("MabNew"+mabCount+"_export").checked =
          mabSync[mabCount].exportNew;
        document.getElementById("MabSyncType"+mabCount).selectedItem =
          document.getElementById("MabSyncType"+mabCount+"_"+mabSync[mabCount].syncType);
        document.getElementById("MabSyncLocation"+mabCount).value =
          mabSync[mabCount].syncLocation;
        document.getElementById("MabFilePath"+mabCount).value =
          mabSync[mabCount].filePath;
        document.getElementById("MabHost"+mabCount).value =
          mabSync[mabCount].syncHost;
        document.getElementById("MabUsername"+mabCount).value =
          mabSync[mabCount].syncUsername;
        document.getElementById("MabPassword"+mabCount).value =
          mabSync[mabCount].syncPassword;

        selectSyncActive( mabCount );
        selectSyncLocation( mabCount );
        createSyncHelp( mabCount );
        selectSyncType( mabCount );
    } // for

    // fill in settings
    try{ useAutoSync = pref.getBoolPref( "SyncMab.useAutoSync" ); } catch(e){}
    try{ useSyncTime = pref.getBoolPref( "SyncMab.useSyncTime" ); } catch(e){}
    try{ syncTime = pref.getIntPref( "SyncMab.syncTime" ); } catch(e){}

    if( syncTime <= 0 )
        syncTime = 1;

    document.getElementById("UseAutoSync").checked = useAutoSync;
    document.getElementById("UseSyncTime").checked = useSyncTime;
    document.getElementById("SyncTime").value = syncTime;

    if( useAutoSync == false )
    {
        document.getElementById("UseSyncTime").disabled = true;
        document.getElementById("SyncTime").disabled = true;
    } // if

} // init



function finish()
{
    storeSyncMabData();

} // finish



function syncronizeNow()
{
    storeSyncMabData();

    syncAddressBooks();

} // syncronizeNow



function storeSyncMabData()
{
    pref.setBoolPref( "SyncMab.useAutoSync", document.getElementById("UseAutoSync").checked );
    pref.setBoolPref( "SyncMab.useSyncTime", document.getElementById("UseSyncTime").checked );
    pref.setIntPref( "SyncMab.syncTime", document.getElementById("SyncTime").value );

    for( mabCount = 0; mabCount < maxMabCount; mabCount++ )
    {
        mabSync = new MabSyncData();
        
        mabSync.syncId = mabCount;
        mabSync.syncActive = document.getElementById("MabSyncActive"+mabCount).checked;
        mabSync.syncType = document.getElementById("MabSyncType"+mabCount).value;
        //mabSync.mabToSync = document.getElementById("MabSyncList"+mabCount).value;
        mabSync.mabToImport = document.getElementById("MabList"+mabCount+"_import").value;
        mabSync.mabToExport = document.getElementById("MabList"+mabCount+"_export").value;
        mabSync.importNew = document.getElementById("MabNew"+mabCount+"_import").checked;
        mabSync.exportNew = document.getElementById("MabNew"+mabCount+"_export").checked;
        mabSync.syncLocation = document.getElementById("MabSyncLocation"+mabCount).value;
        mabSync.filePath = document.getElementById("MabFilePath"+mabCount).value;
        mabSync.syncHost = document.getElementById("MabHost"+mabCount).value;
        mabSync.syncUsername = document.getElementById("MabUsername"+mabCount).value;
        mabSync.syncPassword = document.getElementById("MabPassword"+mabCount).value;
        
        mabSync.store();
    } // for

} // storeSyncMabData



function ChooseFile( mabFileId )
{
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);

    var oldFilePath = document.getElementById( "MabFilePath"+mabFileId ).value;
    if( oldFilePath != "" )
    {
        var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

        try
        {
          file.initWithPath( oldFilePath );
          filePicker.displayDirectory = file;
        }
        catch(e)
        {
        }
    } // if

    var isopen = (document.getElementById("MabSyncType"+mabFileId).value == 'import');
    filePicker.init(window, strings.getString("chooseMab"), (isopen ? nsIFilePicker.modeOpen : nsIFilePicker.modeSave) );
    filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );

    if( filePicker.show() != nsIFilePicker.returnCancel )
    {
        document.getElementById( "MabFilePath"+mabFileId ).value = filePicker.file.path;
        createSyncHelp( mabFileId );
    }

} // ChooseFile



function ChooseFolder( mabFileId )
{
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);

    var oldFilePath = document.getElementById( "MabFilePath"+mabFileId ).value;
    if( oldFilePath != "" )
    {
        var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        
        try
        {
          file.initWithPath( oldFilePath );
          filePicker.displayDirectory = file;
        }
        catch(e)
        {
        }
    } // if

    filePicker.init(window, strings.getString("chooseMabSource"), nsIFilePicker.modeGetFolder );

    if( filePicker.show() != nsIFilePicker.returnCancel )
    {
        document.getElementById( "MabFilePath"+mabFileId ).value = filePicker.file.path;
        createSyncHelp( mabFileId );
    }

} // ChooseFolder



function ExportMab()
{
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);

    var localMabFileName = document.getElementById( "MabListExport" ).selectedItem.value;
    
    if( localMabFileName == "" )
    {
      filePicker.init(window, strings.getString("chooseMabDestination"), nsIFilePicker.modeGetFolder);
    }
    else
    {
      var externMabFileName = document.getElementById( "MabListExport" ).selectedItem.label;

      externMabFileName = escape( externMabFileName );
      externMabFileName += ".mab";

      filePicker.defaultString = externMabFileName;

      filePicker.init(window, strings.getString("chooseMabDestination"), nsIFilePicker.modeSave);
      filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );
    } // else

    if( filePicker.show() != nsIFilePicker.returnCancel )
    {
      if( localMabFileName == "" )
        exportAllAddressBooksViaFile( filePicker.file );
      else
        exportAddressBookViaFile( localMabFileName, filePicker.file );
    } // if

} // ExportMab



function ImportMab()
{
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);

    filePicker.init(window, strings.getString("chooseMabSource"), nsIFilePicker.modeOpen);
    filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );

    if( filePicker.show() == nsIFilePicker.returnOK )
    {
        var localMabFileName = document.getElementById( "MabListImport" ).selectedItem.value;
        importAddressBookViaFile( filePicker.file, localMabFileName );
    } // if

} // ImportMab



function ImportMabFolder()
{
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);

    filePicker.init(window, strings.getString("chooseMabSource"), nsIFilePicker.modeGetFolder);

    if( filePicker.show() == nsIFilePicker.returnOK )
    {
        importAllAddressBooksViaFile( filePicker.file );
    } // if

} // ImportMabFolder



function selectSyncLocation( id )
{
    var location = document.getElementById("MabSyncLocation"+id).value;

    var disabled = ( location == 'file' );

    document.getElementById("MabHost"+id).disabled = disabled;
    document.getElementById("MabUsername"+id).disabled = disabled;
    document.getElementById("MabPassword"+id).disabled = disabled;

    document.getElementById("MabFileBrowse"+id).disabled = !disabled;
    document.getElementById("MabFolderBrowse"+id).disabled = !disabled;

    createSyncHelp( id );
    
} // selectSyncLocation



function selectSyncList( id, type )
{
  document.getElementById("MabSyncType"+id).selectedItem =
    document.getElementById("MabSyncType"+id+"_"+type);
    
  createSyncHelp( id );
  
} // selectSyncList



function createSyncHelp( id )
{
  var syncType = document.getElementById("MabSyncType"+id).value;
  var filePath = document.getElementById("MabFilePath"+id).value;
  var syncLocation = document.getElementById("MabSyncLocation"+id).value;
  var mabToSync;
  var mabToSyncName;
  var help;

  if( syncLocation == 'file' )
  {
    var externFileExists;
    var externMabFile;

    externMabFile = Components.classes["@mozilla.org/file/local;1"].
      createInstance(Components.interfaces.nsILocalFile);

    try
    {
      externMabFile.initWithPath( filePath );
      externFileExists = externMabFile.exists();

      if( externFileExists )
      {
        if( syncType == 'import' )
        {
          if( externMabFile.isDirectory() )
          {
            filePath = externMabFile.leafName;
            help = strings.getString("importall");
            help = help.replace( /_PATH_/g, filePath );
          }
          else
          {
            mabToSync = document.getElementById("MabList"+id+"_import").value;

            if( mabToSync == '' )
              mabToSyncName = getAddressBookNameFromFile( externMabFile );
            else
              mabToSyncName = document.getElementById("MabList"+id+"_import").label;

            filePath = externMabFile.leafName;
            help = strings.getString("importone");
            help = help.replace( /_MAB_/g, mabToSyncName );
            help = help.replace( /_PATH_/g, filePath );
          } // else
        }
        else
        {
          mabToSync = document.getElementById("MabList"+id+"_export").value;

          if( mabToSync == '' )
          {
            if( externMabFile.isDirectory() )
              filePath = externMabFile.leafName;
            else
              filePath = externMabFile.parent.leafName;
            help = strings.getString("exportall");
            help = help.replace( /_PATH_/g, filePath );
          }
          else
          {
            mabToSyncName = document.getElementById("MabList"+id+"_export").label;
            filePath = externMabFile.leafName;
            help = strings.getString("exportone");
            help = help.replace( /_MAB_/g, mabToSyncName );
            help = help.replace( /_PATH_/g, filePath );
          } // else
        } // else
      }
      else
      {
        help = strings.getString("pathnotfound");
      } // else
    }
    catch(e)
    {
      help = strings.getString("patherror");
    } // catch
  }
  else
  if( syncLocation == 'ftp' )
  {
    var isdir = (filePath.lastIndexOf( '/' ) == filePath.length-1);
    if( isdir )
      filePath = filePath.substr( 0, filePath.length-1 );
    fileLeaf = filePath.substr( filePath.lastIndexOf( '/' ) + 1 );

    if( syncType == 'import' )
    {
      if( isdir )
      {
        help = strings.getString("importall");
        help = help.replace( /_PATH_/g, fileLeaf );
      }
      else
      {
        mabToSync = document.getElementById("MabList"+id+"_import").value;

        if( mabToSync == '' )
          mabToSyncName = getAddressBookNameFromFileName( fileLeaf );
        else
          mabToSyncName = document.getElementById("MabList"+id+"_import").label;
          
        help = strings.getString("importone");
        help = help.replace( /_MAB_/g, mabToSyncName );
        help = help.replace( /_PATH_/g, fileLeaf );
      } // else
    }
    else
    {
      mabToSync = document.getElementById("MabList"+id+"_export").value;

      if( mabToSync == '' )
      {
        if( !isdir )
        {
          filePath = filePath.substr( 0, filePath.lastIndexOf( '/' )+1 );
          if( filePath.lastIndexOf( '/' ) == filePath.length-1 )
          {
            filePath = filePath.substr( 0, filePath.length-1 );
            fileLeaf = filePath.substr( filePath.lastIndexOf( '/' ) + 1 );
          } // if
        } // if
          
        if( fileLeaf != "" )
        {
          help = strings.getString("exportall");
          help = help.replace( /_PATH_/g, fileLeaf );
        }
        else
        {
          help = strings.getString("patherror");
        } // else
      }
      else
      {
        mabToSyncName = document.getElementById("MabList"+id+"_export").label;
        help = strings.getString("exportone");
        help = help.replace( /_MAB_/g, mabToSyncName );
        help = help.replace( /_PATH_/g, fileLeaf );
      } // else
    } // else
  }
  else
  {
    var isdir = (filePath.lastIndexOf( '/' ) == filePath.length-1);
    if( isdir )
      filePath = filePath.substr( 0, filePath.length-1 );
    fileLeaf = filePath.substr( filePath.lastIndexOf( '/' ) + 1 );

    if( syncType == 'import' )
    {
      if( isdir )
      {
        help = strings.getString("syncundefined");
      }
      else
      {
        mabToSync = document.getElementById("MabList"+id+"_import").value;

        if( mabToSync == '' )
          mabToSyncName = getAddressBookNameFromFileName( fileLeaf );
        else
          mabToSyncName = document.getElementById("MabList"+id+"_import").label;

        help = strings.getString("importone");
        help = help.replace( /_MAB_/g, mabToSyncName );
        help = help.replace( /_PATH_/g, fileLeaf );
      } // else
    }
    else
    {
      help = strings.getString("syncundefined");
    } // else
  } // else

  document.getElementById("MabSyncHelp"+id).textContent = help;

} // createSyncHelp


function selectSyncType( id )
{
  var type = document.getElementById("MabSyncType"+id).value;
  var showimport = false;
  var showexport = false;

  if( type == 'import' )
    showimport = true;
  else
  if( type == 'export' )
    showexport = true;

  document.getElementById("MabList"+id+"_import").disabled = !showimport;
  document.getElementById("MabNew"+id+"_import").disabled = !showimport;

  document.getElementById("MabList"+id+"_export").disabled = !showexport;
  document.getElementById("MabNew"+id+"_export").disabled = !showexport;

  createSyncHelp( id );
  
} // selectSyncType


function selectSyncActive( id )
{
  document.getElementById("SyncTab"+id).style.color =
    (document.getElementById("MabSyncActive"+id).checked ? '#0000ff' : '');
} // selectSyncActive


