/**
* Filename: syncmabdata.js
* Created:  02.03.2007
* Creator:  Jan Pavek <jan@pavek.de>
*
* Revisions:
*
*/

function MabSyncData( data )
{
  if( data )
  {
    this.syncId = data.syncId;
    this.syncActive = data.syncActive;
    this.syncType = data.syncType;
    this.mabToSync = data.mabToSync;
    this.mabToImport = data.mabToImport;
    this.mabToExport = data.mabToExport;
    this.importNew = data.importNew;
    this.exportNew = data.exportNew;
    this.syncLocation = data.syncLocation;
    this.filePath = data.filePath;
    this.syncHost = data.syncHost;
    this.syncUsername = data.syncUsername;
    this.syncPassword = data.syncPassword;
  }
  else
  {
    this.syncId = 0;
    this.syncActive = false;
    this.syncType = 'export';
    this.mabToSync = '';
    this.mabToImport = '';
    this.mabToExport = '';
    this.importNew = true;
    this.exportNew = true;
    this.syncLocation = 'file';
    this.filePath = '';
    this.syncHost = '';
    this.syncUsername = '';
    this.syncPassword = '';
  } // else

} // MabSyncData


MabSyncData.prototype.store = function()
{
    pref.setBoolPref( "SyncMab.Mab"+this.syncId+".syncActive", this.syncActive );
    pref.setCharPref( "SyncMab.Mab"+this.syncId+".syncType", this.syncType );
    pref.setCharPref( "SyncMab.Mab"+this.syncId+".mabToSync", this.mabToSync );
    pref.setCharPref( "SyncMab.Mab"+this.syncId+".mabToImport", this.mabToImport );
    pref.setCharPref( "SyncMab.Mab"+this.syncId+".mabToExport", this.mabToExport );
    pref.setBoolPref( "SyncMab.Mab"+this.syncId+".importNew", this.importNew );
    pref.setBoolPref( "SyncMab.Mab"+this.syncId+".exportNew", this.exportNew );
    pref.setCharPref( "SyncMab.Mab"+this.syncId+".syncLocation", this.syncLocation );
    pref.setCharPref( "SyncMab.Mab"+this.syncId+".filePath", this.filePath );
    pref.setCharPref( "SyncMab.Mab"+this.syncId+".syncHost", this.syncHost );
    pref.setCharPref( "SyncMab.Mab"+this.syncId+".syncUsername", this.syncUsername );
    pref.setCharPref( "SyncMab.Mab"+this.syncId+".syncPassword", this.syncPassword );

} // MabSyncData.prototype.store


MabSyncData.prototype.load = function( id )
{
    this.syncId = id;

    try { this.syncActive = pref.getBoolPref( "SyncMab.Mab"+this.syncId+".syncActive" ); }
    catch(e) {}

    try { this.syncType = pref.getCharPref( "SyncMab.Mab"+this.syncId+".syncType" ); }
    catch(e) {}

    try { this.mabToSync = pref.getCharPref( "SyncMab.Mab"+this.syncId+".mabToSync" ); }
    catch(e) {}

    try { this.mabToImport = pref.getCharPref( "SyncMab.Mab"+this.syncId+".mabToImport" ); }
    catch(e) { this.mabToImport = this.mabToSync; this.syncActive = false; }

    try { this.mabToExport = pref.getCharPref( "SyncMab.Mab"+this.syncId+".mabToExport" ); }
    catch(e) { this.mabToExport = this.mabToSync; }

    try { this.importNew = pref.getBoolPref( "SyncMab.Mab"+this.syncId+".importNew" ); }
    catch(e) {}

    try { this.exportNew = pref.getBoolPref( "SyncMab.Mab"+this.syncId+".exportNew" ); }
    catch(e) {}

    try { this.syncLocation = pref.getCharPref( "SyncMab.Mab"+this.syncId+".syncLocation" ); }
    catch(e) {}

    try { this.filePath = pref.getCharPref( "SyncMab.Mab"+this.syncId+".filePath" ); }
    catch(e) {}

    try { this.syncHost = pref.getCharPref( "SyncMab.Mab"+this.syncId+".syncHost" ); }
    catch(e) {}

    try { this.syncUsername = pref.getCharPref( "SyncMab.Mab"+this.syncId+".syncUsername" ); }
    catch(e) {}

    try { this.syncPassword = pref.getCharPref( "SyncMab.Mab"+this.syncId+".syncPassword" ); }
    catch(e) {}

} // MabSyncData.prototype.load


